100 REMark $$asmb=flp1_qlib_ext,0,12
110 REMark $$asmb=flp1_edline_code,0,10
120 REMark $$asmb=flp1_djtoolkit_bin,0,12
130 REMark $$asmb=flp1_display_cde,0,10
140 REMark $$asmb=flp1_dictionary_cfg,0,12
150 :
160 REMark German - English Wordlist
170 REMark A. Pemberton 1991 --- Public Domain
180 REMark substantially modified by Dilwyn Jones Feb 2001
190 :
200 def_dictionary$ = C_STRG$(1)
210 :
220 IF Q_MYJOB <> 0 : OPEN #0,'con'
230 :
240 wx% = 32 : wy% = 16 : REMark window initial co-ordinates
250 WINDOW #0,448,142,wx%,wy% : PAPER #0,0 : INK #0,7 : CLS #0
260 BORDER #0,1,2,7
270 :
280 OPEN #3,'con'
290 OPEN #4,'scr'
300 Dictionary
310 :
320 DEFine PROCedure Dictionary
330   base = 0 : REMark no dictionary loaded yet (no heap space reserved)
340   REPeat program
350     CLS #0 : INK #0,4
360     PRINT #0,"    ***  DICTIONARY  ***  [ Based on WordList by Alan Pemberton 1991 ]"
370     INK #0,7
380     PRINT #0,\'Enter filename of dictionary to be loaded:'
390     dd$ = EDLINE$(#0,41,def_dictionary$)
400     IF dd$ = '' THEN EXIT program
410     def_dictionary$ = dd$
420     Init : REMark fetch dictionary file
430     Windows : REMark draw main display
440     REPeat main
450       AT #3,1,17 : PRINT #3,FILL$(' ',20) : AT #3,1,17
460       target$ = EDLINE$(3,20,"") : CURSOR #3,377,23
470       IF target$ = '*' OR target$ = '"*"' : EXIT program
480       REMark start from beginning of dictionary?
490       IF target$ = "" : target$ = first_char$
500       Scroll_Display
510       IF leave = 1 : EXIT main
520     END REPeat main
530   END REPeat program
540   IF base > 0 : RELEASE_HEAP base
550   CLOSE #3 : CLOSE #4
560 END DEFine Dictionary
570 :
580 DEFine PROCedure Init
590   :
600   REMark load dictionary and set initial settings
610   REMark if replacing a previous dictionary, "forget" that one
620   IF base > 0 THEN RELEASE_HEAP base
630   :
640   REMark check presence and size of wordlist configured
650   PRINT #0,'Please wait, loading'!def_dictionary$
660   list_size = FILE_LENGTH(def_dictionary$)
670   IF list_size <= 0 THEN
680     PRINT #0,"Wordlist file not found" : PAUSE 50 : STOP
690   END IF
700   :
710   REMark we need to reserve enough space to surround the file with
720   REMark linefeed characters to protect the searches
730   REMark due to the need for word address alignment, we need to
740   REMark allocate 2 extra each end for loading to even address
750   base = RESERVE_HEAP(list_size+4) : REMark base of aalocated memory
760   IF base <= 0 THEN
770     REMark oops...
780     PRINT #0,'Out of memory' : PAUSE 50 : STOP
790   END IF
800   :
810   REMark try to load the dictionary file
820   Q_ERR_ON 'lbytes'
830   LBYTES def_dictionary$,base+2
840   fer = Q_ERR : Q_ERR_OFF 'lbytes'
850   IF fer THEN
860     REMark oops...
870     PRINT #0,"Wordlist file not found" : PAUSE 50 : STOP
880   END IF
890   :
900   REMark surround dictionary with 2 linefeeds
910   POKE base,10 : POKE base+1,10 : REMark before...
920   POKE base+2+list_size,10: POKE base+2+list_size+1,10: REMark after
930   :
940   REMark is there already a linefeed at the start of the file?
950   IF PEEK(base+2) = 10 THEN
960     list_addr = base + 2 : REMark yes there was
970   ELSE
980     list_addr = base + 1 : REMark no, one had to be added
990     list_size = list_size + 1
1000   END IF
1010   :
1020   REMark the word list also needs to end with an LF so that the
1030   REMark searches are protected by having a guaranteed LF to find
1040   IF PEEK(list_addr+list_size-1) = 10 THEN
1050     REMark there is already an LF at end of file
1060     REMark list_size OK as it is
1070   ELSE
1080     list_size = list_size + 1 : REMark extend to reach closing LF
1090   END IF
1100   list_end_addr = list_addr + list_size - 1
1110   :
1120   REMark what is th efirst text character in the file?
1130   first_char$ = 'a' : REMark default start of dictionary
1140   FOR a = list_addr TO list_end_addr
1150     IF PEEK(a) > 31 THEN first_char$ = PEEK_STRING(a,1) : EXIT a
1160   END FOR a
1170   :
1180 END DEFine Init
1190 :
1200 DEFine PROCedure Windows
1210   REMark #3 is main window outline
1220   REMark #4 is scrolling window displaying translations
1230   WINDOW #0,448,142,wx%,wy% : BORDER #0,1,2,7
1240   WINDOW #3,448,142,wx%,wy%
1250   PAPER #3,2,0 : CLS #3 : PAPER #3,0 : INK #3,7
1260   BORDER #3,1,2,7 : CLS #3,3
1270   PRINT #3,"    ***  DICTIONARY  ***  [ Based on WordList by Alan Pemberton 1991 ]"
1280   PAPER #3,2,1 : CURSOR #3,24,12 : PRINT #3,'Search for:-                       [ Enter "*" to quit ]'
1290   AT #3,11,0 : PAPER #3,0 : CLS #3,3 : CLS #3,2
1300   PRINT #3,"[Cursor keys to scroll] [ESC - exit scrolling] [F4 / SHIFT F5 - redraw]"
1310   PRINT #3,'[F3 - Load a dictionary file] [CTRL F3/F4 - Move]'
1320   PRINT #3,'CURRENT DICTIONARY : ';def_dictionary$;
1330   REMark open inner window for display of dictionary entries
1340   WINDOW #4,398,80,wx%+26,wy%+26
1350   PAPER #4,0 : INK #4,4 : CLS #4
1360   WINDOW #3,448,50,wx%,wy%+3
1370 END DEFine Windows
1380 :
1390 DEFine PROCedure Scroll_Display
1400   LOCal a,ad1
1410   Show_List Find_Word(target$,list_addr)
1420   REPeat lupe
1430     AT #3,2,73 : Q_CURSON #3 : key = CODE(INKEY$(#3,-1)) : Q_CURSOFF #3
1440     SELect ON key
1450       =208 : REMark up (back 1 in list)
1460              IF word_addr(0) > list_addr THEN
1470                ad1 = Back_Search(word_addr(0)-1,list_addr,10)
1480                REMark ad1 now points to new word_addr(0)
1490                FOR a = 8 TO 1 STEP -1 : word_addr(a)=word_addr(a-1)
1500                word_addr(0) = ad1 : REMark the new entry
1510                SCROLL #4,10
1520                ad1 = Extract_Entry(word_addr(0))
1530                AT #4,0,0 : PRINT #4,x1$ TO 30;x2$;
1540              END IF
1550       =216 : REMark down
1560              IF word_addr(8) < list_end_addr THEN
1570                REMark there could be another entry to scroll down to
1580                SCROLL #4,-10
1590                ad1 = Extract_Entry (word_addr(8))
1600                FOR a = 0 TO 7 : word_addr(a) = word_addr(a+1)
1610                word_addr(8) = ad1
1620                AT #4,7,0 : PRINT #4,x1$ TO 30;x2$;
1630              END IF
1640       =27 : REMark esc
1650             leave = 0 : EXIT lupe
1660       =212,221 : REMark shift up/alt shift up
1670              IF key = 212 THEN
1680                word_addr(8) = word_addr(0) : REMark last position
1690              ELSE
1700                word_addr(8) = list_end_addr : REMark end of list
1710              END IF
1720              CLS #4
1730              REMark step back 8 linefeeds or to start of list
1740              num_lf = 0
1750              ad1 = list_addr : REMark in case not found
1760              FOR a = word_addr(8)-1 TO list_addr STEP -1
1770                IF PEEK(a) = 10 THEN
1780                  num_lf = num_lf+1
1790                  IF num_lf = 8 THEN ad1 = a : EXIT a
1800                END IF
1810              END FOR a
1820              Show_List ad1
1830       =220 : REMark shift down
1840              REMark may not be displaying all 8 lines
1850              ad1 = word_addr(8)
1860              IF ad1 >= list_end_addr THEN
1870                REMark was already showing last item in list
1880                FOR a = 7 TO 0 STEP -1
1890                  IF word_addr(a) > 0 THEN
1900                    ad2 = word_addr(a) : EXIT a
1910                  END IF
1920                END FOR a
1930                Show_List ad2
1940              ELSE
1950                Show_List ad1
1960              END IF
1970       =213 : REMark shift alt up to beginning
1980              Show_List list_addr
1990       =244,250 : REMark refresh display
2000                  Windows
2010                  AT #3,1,17 : PRINT #3,FILL$(' ',20) : AT #3,1,17
2020                  PRINT #3,target$;
2030                  temp = word_addr(0) : REMark array gets dimensioned
2040                  Show_List temp
2050       =240 : REMark F3 - change dictionary
2060              leave = 1 : EXIT lupe
2070       =241,245 : REMark move window over display
2080                  Relocate
2090                  Windows
2100                  AT #3,1,17 : PRINT #3,FILL$(' ',20) : AT #3,1,17
2110                  PRINT #3,target$;
2120                  temp = word_addr(0) : REMark array gets dimensioned
2130                  Show_List temp
2140       =32 TO 191 : REMark jump to word starting with that character
2150         ad1 = SEARCH_I(list_addr,list_size-1,CHR$(10)&CHR$(key))
2160         IF ad1 > 0 THEN Show_List ad1
2170     END SELect
2180   END REPeat lupe
2190 END DEFine Scroll_Display
2200 :
2210 REMark $$off
2220 DEFine PROCedure Sa
2230   REMark don't try to compile this procedure!
2240   QSAVE flp1_DICTIONARY : SAVE flp1_DICTIONARY_bas
2250 END DEFine Sa
2260 REMark $$on
2270 :
2280 DEFine FuNction Find_Word (z$,look_from)
2290   LOCal a,ad1
2300   REMark find z$ in the word list,return address of LF before z$
2310   REMark search from  look_from
2320   REMark N.B. ** this routine does not itself update addr1/addr2 **
2330   REMark we first search for the whole word and progressively look
2340   REMark look for match of shorter versions (i.e. first few letters)
2350   FOR a = LEN(z$) TO 1 STEP -1
2360     REMark the 2 LFs at end ensure we don't find beyond end of list
2370     ad1 = SEARCH_I(look_from,list_end_addr-look_from+1,CHR$(10)&z$)
2380     IF ad1 > 0 THEN EXIT a : REMark found
2390   NEXT a
2400     REMark if it gets here into the loop epilogue, no match found,
2410     REMark so return first entry in dictionary
2420     ad1 = list_addr
2430   END FOR a
2440   RETurn ad1 : REMark address of LF before word found or list start
2450 END DEFine Find_Word
2460 :
2470 DEFine FuNction Extract_Entry (look_from)
2480   LOCal star,ad2,x$
2490   REMark locate next LF to flag end of this record
2500   ad2 = SEARCH_C(look_from+1,list_end_addr-look_from+1,CHR$(10))
2510   x$ = PEEK_STRING(look_from+1,ad2-look_from-1) : REMark no LFs!
2520   star = '*' INSTR x$
2530   SELect ON star
2540     =0 : REMark whole entry must be original word
2550          x1$ = x$ : x2$ = '' : REMark no translation
2560     =1 : REMark no original word, all translation
2570          x1$ = '' : x2$ = ''
2580          IF LEN(x$) > 1 THEN x2$ = x$(2 TO LEN(x$))
2590     =LEN(x$) : REMark no translation
2600       x1$ = '' : x2$ = ''
2610       IF LEN(x$) > 1 THEN x1$ = x$(1 TO star-1)
2620     =REMAINDER : REMark a normal entry
2630       x1$ = x$(1 TO star-1) : REMark original word
2640       x2$ = x$(star+1 TO LEN(x$)) : REMark translation
2650   END SELect
2660   RETurn ad2: REMark returns address of LF where this entry finishes
2670 END DEFine Extract_Entry
2680 :
2690 DEFine PROCedure Show_List (where_from)
2700   LOCal a,b,next_word
2710   REMark display an 8 line list starting with the word at ad1
2720   REMark ad1 points to LF just before the first word
2730   CLS #4 : REMark clear any previous content
2740   DIM word_addr(8) : REMark pointers to start of each line
2750   next_word = where_from
2760   FOR a = 0 TO 7
2770     REMark find LF after entry
2780     REMark but if already at end, no more to display!
2790     IF next_word >= list_end_addr THEN
2800       REMark at end of list
2810       FOR b = a TO 7 : word_addr(a) = 0
2820       EXIT a
2830     END IF
2840     word_addr(a) = next_word
2850     next_word = Extract_Entry (word_addr(a))
2860     AT #4,a,0 : PRINT #4,x1$ TO 30;x2$;
2870     REMark next_word now points to LF after this entry(start of next)
2880   END FOR a
2890   word_addr(8) = next_word : REMark end of last line
2900 END DEFine Show_List
2910 :
2920 DEFine FuNction Back_Search (from,_to_,cde)
2930   LOCal a,adr
2940   adr = 0 : REMark not found assumed
2950   FOR a = from TO _to_ STEP -1
2960     IF PEEK(a) = cde : adr = a : EXIT a
2970   END FOR a
2980   RETurn adr
2990 END DEFine Back_Search
3000 :
3010 DEFine PROCedure Relocate
3020   LOCal key,loop,mx%,my%
3030   mx% = FLIM_W(#0) : REMark maximum width of display
3040   my% = FLIM_H(#0) : REMark maximum height of display
3050   BORDER #0,0
3060   REPeat loop
3070     WINDOW #0,448,142,wx%,wy% : Outline_Box
3080     CURSOR #0,2,1 : Q_CURSON #0 : key = CODE(INKEY$(-1))
3090     Q_CURSOFF #0 : Outline_Box
3100     SELect ON key
3110       =192 : wx% = wx%-(2*(wx%>0))           : REMark left
3120       =200 : wx% = wx% + (2*(wx%<(mx%-448))) : REMark right
3130       =208 : wy% = wy% - (wy%>0)             : REMark up
3140       =216 : wy% = wy%+(wy%<(my%-142))       : REMark down
3150       =REMAINDER : EXIT loop : REMark any other key ends
3160     END SELect
3170   END REPeat loop
3180 END DEFine Relocate
3190 :
3200 DEFine PROCedure Outline_Box
3210   REMark draw the outline of the program when moving around screen
3220   OVER #0,-1 : BLOCK #0,448,1,0,0,7
3230   BLOCK #0,2,140,446,1,7
3240   BLOCK #0,448,1,0,141,7
3250   BLOCK #0,2,140,0,1,7 : OVER #0,0
3260 END DEFine Outline_Box
3270 :
3280 REMark $$off
3290 DEFine PROCedure TEST
3300   REMark checks lengths of words and translations
3310   CLS : CLS #0
3320   INPUT #0,'File > ';f$
3330   OPEN_IN #3,f$
3340   long1 = 0 : REMark length of original words...
3350   long2 = 0 : REMark ...and length of translations
3360   lines = 0 : REMark number of lines in this file
3370   CLS #0
3380   REPeat loop
3390     IF EOF(#3):EXIT loop
3400     INPUT #3,t$
3410     lines = lines+1
3420     IF lines - (100*(INT(lines/100))) = 0 THEN AT #0,0,0 : PRINT #0,lines
3430     star = '*' INSTR t$
3440     IF star > long1 THEN long1 = star-1
3450     IF (LEN(t$)-star) > long2 THEN long2 = (LEN(t$)-star)
3460   END REPeat loop
3470   PRINT'Widest word:';long1
3480   PRINT\'Widest translation:';long2
3490   PRINT\lines;' lines'
3500 END DEFine TEST
3510 REMark $$on
